from StringIO import StringIO

def useViewAction(self, out):
    """use view action in listings"""
    props = self.portal_properties.site_properties
    
    useView = getattr(props, 'typesUseViewActionInListings', None)
    if useView is not None:
        if 'ATVideo' not in useView:
            props._updateProperty('typesUseViewActionInListings', list(useView) + ['ATVideo']) 
            

def addCTRExtensions(self, out):
    """
    add predicates for 'ATVideo' file extensions to the content type registry
    """
    ## make this configurable ???
    predicate_id = 'video_ext'
    extensions = 'mov, wmv, rm, avi, mpg'  # comma separated list
    type_name = 'ATVideo'
    
    ctr = self.content_type_registry
    predicate_ids = [p[0] for p in ctr.listPredicates()]
    if predicate_id not in predicate_ids:
        ctr.addPredicate(predicate_id, 'extension')
        out.write("Adding a '%s' predicate to the content type registry\n"\
                  % predicate_id)
    predicate = ctr.getPredicate(predicate_id)
    predicate.edit(extensions)
    ctr.updatePredicate(predicate_id, predicate, type_name)
    ctr.reorderPredicate(predicate_id, 0)
    out.write("'%s' Predicates installed.\n" % extensions)
    
def addCTRMimetypes(self, out):
    """
    add a predicate for 'ATVideo' mime type to the content type registry
    """
    predicate_id = 'video'
    mimetype = 'video'
    type_name = 'ATVideo'

    ctr = self.content_type_registry
 
    if ctr.getPredicate(predicate_id):
        out.write("Adding a '%s' predicate to the content type registry\n"\
                  % predicate_id)
        ctr.removePredicate(predicate_id)
    ctr.addPredicate(mimetype, 'major_minor')
    ctr.getPredicate(predicate_id).edit(major=mimetype, minor='')
    ctr.assignTypeName(predicate_id, type_name)
    ctr.reorderPredicate(predicate_id, 1)
    out.write("Predicate for MIME type '%s' installed.\n" % mimetype)
    
def install(self):
    """
    Install method for ATVideo
    """
    out = StringIO()
    useViewAction(self, out)
    addCTRExtensions(self, out)
    addCTRMimetypes(self, out)
    return out.getvalue()