# File: video.py
#
# Copyright (c) 2006 by Nate Aune (Jazkarta)
# Generator: ArchGenXML Version 1.4.1 svn/devel
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Nate Aune (Jazkarta) <natea@jazkarta.com>, Christof Haemmerle (nex9)
<reco@buero-newyork.com>, Chris Miles <chris@chrismiles.info>, Andy Nicholson
<andy@cat.org.au>"""
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *

from Products.ATMediaFile.content.mediafile import ATMediaFile
from Products.ATVideo.interfaces.IVideoMetaData import IVideoMetaData


from Products.ATVideo.config import *
#code-section module-header #fill in your manual code here

if HAS_LINGUA_PLONE:
    from Products.LinguaPlone.public import *

#/code-section module-header

schema = Schema((

    #user uploaded thumbnail image for the image
    ImageField(
        name='thumbnailImage',
        schemata="default",
        widget=ImageWidget(
            label="Thumbnail Image",
            description="Please upload your thumbnail image representing the video",
            label_msgid='ATVideo_label_thumbnailImage',
            description_msgid='ATVideo_help_thumbnailImage',
            i18n_domain='ATVideo',
        ),
        languageIndependent=1,
        storage=AttributeStorage(),
        sizes={'small':(120,120),'medium':(200,200),'large':( 400,400)}
    ),

    StringField(
        name='publisherName',
        widget=StringWidget(
            label="Publisher",
            description="The publisher of this video",
            label_msgid='ATVideo_label_publisherName',
            description_msgid='ATVideo_help_publisherName',
            i18n_domain='ATVideo',
        ),
        languageIndependent=1,
        schemata="videometadata"
    ),

    StringField(
        name='productionCompanyName',
        widget=StringWidget(
            label="Production company",
            description="The production company of this video",
            label_msgid='ATVideo_label_productionCompanyName',
            description_msgid='ATVideo_help_productionCompanyName',
            i18n_domain='ATVideo',
        ),
        languageIndependent=1,
        schemata="videometadata"
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

ATVideo_schema = getattr(ATMediaFile,'schema',Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class ATVideo(ATMediaFile):
    security = ClassSecurityInfo()
    __implements__ = (getattr(IVideoMetaData,'__implements__',()),) + (IVideoMetaData,)


    # This name appears in the 'add' box
    archetype_name = 'Video'

    meta_type = 'ATVideo'
    portal_type = 'ATVideo'
    allowed_content_types = [] + list(getattr(ATMediaFile, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 1
    allow_discussion = False
    #content_icon = 'ATVideo.gif'
    immediate_view = 'base_view'
    default_view = 'video_view'
    suppl_views = ()
    typeDescription = "Video"
    typeDescMsgId = 'description_edit_atvideo'

    schema = ATVideo_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    # Methods
    security.declarePublic('stream')
    def stream(self):
        """
        
        """
        
        pass

    # Methods from Interface IVideoMetaData
    security.declarePublic('getMetaDuration')
    def getMetaDuration(self):
        """
        
        """
        
        pass

    security.declarePublic('getMetaBitRate')
    def getMetaBitRate(self):
        """
        
        """
        
        pass

    security.declarePublic('getMetaCodec')
    def getMetaCodec(self):
        """
        
        """
        
        pass

    security.declarePublic('getMetaPublisher')
    def getMetaPublisher(self):
        """
        
        """
        
        pass

    security.declarePublic('setMetaPublisher')
    def setMetaPublisher(self):
        """
        
        """
        
        pass

    security.declarePublic('getMetaProductionCompany')
    def getMetaProductionCompany(self):
        """
        
        """
        
        pass

    security.declarePublic('setMetaProductionCompany')
    def setMetaProductionCompany(self):
        """
        
        """
        
        pass

    # Manually created methods

    def getStreamPath(self, file_id=""):
        """ return the stream path for file_id """
        if not file_id:
            return ""
        
        # hardcode this until we implement media_server in the video_tool or media_tool    
        media_server = ""
        relative_path = ""
        
        if media_server:
            path = relative_path + '/' + file_id
        else:
            path = self.absolute_url()
        return path

    # convenience method for getting the image tag - borrowed from ATImage
    def tag(self, **kwargs):
        """Generate image tag using the api of the ImageField
        """
        return self.getField('thumbnailImage').tag(self, **kwargs)



registerType(ATVideo,PROJECTNAME)
# end of class ATVideo

##code-section module-footer #fill in your manual code here
##/code-section module-footer



