import os
import dbm

DBFILE = '/tmp/limewire_db'
HIST = -5

## def inputfilter(filter):
##     """ look for x-node header and save it somewhere """
##     log('starting inputfilter')

##     # we're done if we're in a subrequest
##     if filter.req.main is not None:
##         filter.pass_on()
##         return
    
##     xnode = filter.req.headers_in.get('x-node')
##     if xnode is None or not xnode:
##         filter.pass_on()
##         filter.flush()
##         return
##     xnode = xnode.strip()

##     log('got xnode')

##     # otherwise save them somewhere
##     sha = getsha(filter)
##     db = dbm.open(DBFILE, 'c')
##     log('before: %s %s %s' % (sha, xnode, db.keys()))
##     if db.has_key(sha):
##         existing = db[sha]
##         log('existing: %s' % existing)
##         xnodes = existing.split(',')
##         xnodes = [ node.strip() for node in xnodes ]
##         log('xnodes: %s' % str(xnodes))
##         xnodes = xnodes[HIST:]
##         if xnode not in xnodes:
##             xnodes.append(xnode)
##         db[sha] = ','.join(xnodes)
##     else:
##         db[sha] = xnode

##     log('after: %s %s %s' % (sha, xnode, db.keys()))

##     db.close()
##     filter.pass_on()
##     filter.close()


def outputfilter(filter):
    """ lookup any other nodes saved for this file and serve them up too """

    # we're done if we're in a subrequest
    if filter.req.main is not None:
        filter.pass_on()
        return

    sha = getsha(filter)

    xnode = filter.req.headers_in.get('x-node')

    # lookup in db
    db = dbm.open(DBFILE, 'c')
    if db.has_key(sha):
        xnodes = db[sha]
        if xnode is not None:
            xnodes = xnodes.split(',')
            xnodes = [ node.strip() for node in xnodes ]
            xnodes = [ node for node in xnodes if node != xnode ]

        if xnodes:
            xnodes = ','.join(xnodes)
            filter.req.headers_out.add('x-alt', xnodes)

    if xnode is None or not xnode:
        filter.pass_on()
        filter.flush()
        return
    xnode = xnode.strip()

    # otherwise save them somewhere
    if db.has_key(sha):
        existing = db[sha]
        xnodes = existing.split(',')
        xnodes = [ node.strip() for node in xnodes ]
        xnodes = xnodes[HIST:]
        if xnode not in xnodes:
            xnodes.append(xnode)
        db[sha] = ','.join(xnodes)
    else:
        db[sha] = xnode

    db.close()

    filter.pass_on()
    filter.flush()
    


def log(data):
    f = open('/tmp/limewire.log', 'ab')
    f.write(data)
    f.write('\n')
    f.close()


def getsha(filter):
    bits = filter.req.parsed_uri
    log(str(bits))
    qs = bits[7]
    sha = qs.split(':')[2]
    return sha
